#include "polproblem.h"

PolProblem::PolProblem(int k,Dataset *d)
    :Problem(k)
{
    data = d;
    paramk = k;
    left.resize(k);
    right.resize(k);
    for(int i=0;i<k;i++)
    {
        left[i]=-5.0;
        right[i]=5.0;
    }
}
double PolProblem::funmin(Data &x)
{
    ak = x;
    double error = 0.0;
    for(int i=0;i<data->count();i++)
    {
        Data xx = data->getXPoint(i);
        double yy = data->getYPoint(i);
        double value = pol(xx[0]);
        error+=(yy-value)*(yy-value);
    }
    return error;
}

Data   PolProblem::gradient(Data &x)
{
    Data g ;
    g.resize(x.size());
    for(int i=0;i<paramk;i++)
        g[i]=0.0;
    ak = x;
    for(int j=0;j<data->count();j++)
    {
        Data xx = data->getXPoint(j);
        double yy = data->getYPoint(j);
        double value = pol(xx[0]);
        for(int j=1;j<paramk;j++)
        {
            double gtemp = -pow(xx[0],j);
            g[j]+=(yy-value)*gtemp;
        }
    }
    for(int i=0;i<paramk;i++)
        g[i]=2.0*g[i];
    return g;
}

double PolProblem::pol(double x)
{
    double value = 0.0;
    for(int i=0;i<paramk;i++)
    {
        value = value + ak[i]*pow(x,i);

    }
    return value;
}

PolProblem::~PolProblem()
{
    //nothing here
}
